import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';

class ChatScreen2 extends StatefulWidget {
  const ChatScreen2({Key? key}) : super(key: key);

  @override
  State<ChatScreen2> createState() => _ChatScreen2State();
}

class _ChatScreen2State extends State<ChatScreen2> {
  final List<Chat> _chat=[
    Chat(
      message:'Hi',
      date:DateTime.parse('2023-06-30 08:12:38'),
      sentByMe:true
    ),

    Chat(
        message:'Hi John, how are you?',
        date:DateTime.parse('2023-06-30 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'fine, you?',
        date:DateTime.parse('2023-06-30 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'me too, long time no see',
        date:DateTime.parse('2023-06-30 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Yes, very busy in work now',
        date:DateTime.parse('2023-06-30 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'Can we meet?',
        date:DateTime.parse('2023-07-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Yes, next sunday I am free',
        date:DateTime.parse('2023-07-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'Ok, I will call you then',
        date:DateTime.parse('2023-07-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Did you change your job or still working there?',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'No, changed my job last year. Now I am getting more time for me. Last job was eating my whole day time.',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:false
    ),
    Chat(
        message:'Good to know. Nowadays job is taking full life. No employer wants to give us some time to spent for ourselves',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:true
    ),
    Chat(
        message:'Ok, see you later.',
        date:DateTime.parse('2023-08-31 08:12:38'),
        sentByMe:true
    ),
  ];

  @override
  Widget build(BuildContext context) {
    const myColor=Colors.pink;
    Size screenSize=MediaQuery.of(context).size;
    return  Scaffold(
      appBar: AppBar(
        leadingWidth: 70,
        // titleSpacing: 20,
        toolbarHeight: 70,
        elevation: 5,
        backgroundColor: myColor,
        systemOverlayStyle: SystemUiOverlayStyle(statusBarColor: Colors.transparent),
        leading: Container(
          margin: EdgeInsets.only(left:10),
          decoration: BoxDecoration(
            shape: BoxShape.circle,
            image: DecorationImage(image: AssetImage('assets/user.jpg'))
          ),
            ),
        title: Text('John Doe',),
        titleTextStyle: TextStyle(fontWeight: FontWeight.bold,fontSize: 25),
        actions: [
          IconButton(onPressed: (){}, icon: Icon(Icons.call)),
          IconButton(onPressed: (){}, icon: Icon(Icons.video_call)),
          IconButton(onPressed: (){}, icon: Icon(Icons.info)),
        ],
      ),
      body: Column(
        children: [
          Expanded(
            child: ListView.builder(
              shrinkWrap: true,
              itemCount: _chat.length,
                itemBuilder: (context,index){
                  Chat chat=_chat[index];
                  bool issamedate = true;
                  final DateTime date = chat.date;
                  if (index == 0) {
                    issamedate = false;
                  } else {
                    final DateTime prevdate = _chat[index-1].date;
                    issamedate = date._issamedate(prevdate);
                  }
                  return Column(
                    children: [
                      SizedBox(height: 10,),

                      index ==0 || !(issamedate)?
                      Column(
                        children: [
                          Divider(),
                          Container(
                            padding: EdgeInsets.symmetric(horizontal: 15,vertical: 8),
                            decoration: BoxDecoration(
                              color: Colors.grey.shade200,borderRadius: BorderRadius.circular(5)
                            ),
                              child: Text(date.formatdate(),style: TextStyle(color:Colors.black54),)),
                        ],
                      ):Container(),
                      Align(
                        alignment: chat.sentByMe?Alignment.centerRight:Alignment.centerLeft,
                        child: ConstrainedBox(
                          constraints: BoxConstraints(maxWidth: screenSize.width*.9),
                          child: Container(
                            padding: EdgeInsets.symmetric(horizontal: 10,vertical: 10),
                            margin: EdgeInsets.symmetric(horizontal: 20,vertical: 15),

                            decoration: BoxDecoration(
                              gradient: chat.sentByMe?LinearGradient(
                                begin: Alignment.topRight,
                                end: Alignment.bottomLeft,
                                colors: [
                                  myColor,
                                  myColor,
                                  Colors.indigo,
                                ],
                              ):LinearGradient(
                                begin: Alignment.topRight,
                                end: Alignment.bottomLeft,
                                colors: [
                                  myColor.shade900,
                                  myColor.shade400,
                                ],
                              ),
                              borderRadius: chat.sentByMe?const BorderRadius.only(
                                  bottomRight: Radius.circular(15),
                                  bottomLeft: Radius.circular(15),
                                  topLeft: Radius.circular(15)):
                              const BorderRadius.only(
                                  bottomRight: Radius.circular(15),
                                  bottomLeft: Radius.circular(15),
                                  topRight: Radius.circular(15))

                            ),
                            child: Text(chat.message,style: const TextStyle(
                                color: Colors.white,fontSize: 18
                            ),),
                          ),
                        ),
                      ),
                    ],
                  );
                }),
          ),
          Padding(
            padding: const EdgeInsets.all(8.0),
            child: TextField(
              maxLines: null,
              decoration: InputDecoration(
                prefixIcon: IconButton(onPressed: () {  }, icon: Icon(Icons.emoji_emotions,size: 25,color: myColor,),),
                suffixIcon: Row(
                  mainAxisAlignment: MainAxisAlignment.end,
                  children: [
                    IconButton(onPressed: () {  }, icon: Icon(Icons.send,size: 25,color: myColor,),),
                    IconButton(onPressed: () {  }, icon: Icon(Icons.attach_file,size: 25,color: myColor,),),
                  ],
                ),
                enabledBorder: OutlineInputBorder(
                  borderSide: BorderSide(width: 2,color: Colors.grey),
                  borderRadius: BorderRadius.circular(15)
                ),
                  focusedBorder: OutlineInputBorder(
                      borderSide: BorderSide(width: 2,color: myColor),
                      borderRadius: BorderRadius.circular(15)
                  ),
                hintText: 'Type here.....'
              ),
              
            ),
          )
        ],
      ),
    );
  }
}

class Chat {
  final String message;
  final DateTime date;
  final bool sentByMe;

  const Chat({
    required this.message,
    required this.date,
    required this.sentByMe
});
}

const String dateformatter = 'dd-MMM, yy';

extension datehelper on DateTime {

  String formatdate() {
    final formatter = DateFormat(dateformatter);
    return formatter.format(this);
  }
  bool _issamedate(DateTime other) {
    return this.year == other.year &&
        this.month == other.month &&
        this.day == other.day;
  }

  int getdifferenceindayswithnow() {
    final now = DateTime.now();
    return now.difference(this).inDays;
  }
}
